import { StackedPanel } from '@lumino/widgets';
import { EditorView } from './editorWidget';
/**
 * The class name added to the panels.
 */
const PANEL_CLASS = 'jp-RovaPanel';
/**
 * A panel which has the ability to add other children.
 */
export class EditorPanel extends StackedPanel {
    constructor(handler) {
        super();
        this._handler = handler;
        this.addClass(PANEL_CLASS);
        this.id = 'gquant-editor-panel';
        this.title.label = 'Node Editor';
        this.title.closable = true;
        this._example = new EditorView(this._handler);
        this.addWidget(this._example);
    }
    onResize(msg) {
        console.log('here');
        console.log(msg);
    }
    dispose() {
        super.dispose();
    }
    get handler() {
        return this._handler;
    }
}
