// eslint-disable-next-line @typescript-eslint/no-unused-vars
import React from 'react';
import { COMMAND_SELECT_FILE, COMMAND_SELECT_PATH, COMMAND_OPEN_DOC_FORWARD } from './commands';
import styled from '@emotion/styled';
function uuidv4() {
    return Math.random()
        .toString(36)
        .substring(2, 15);
}
export class TaskgraphSelector extends React.Component {
    constructor(props) {
        super(props);
    }
    render() {
        const Input = styled.input `
      width: 100%;
    `;
        const Group = styled.div `
      width: 100%;
    `;
        this._id = 'taskgraph_editor_"' + uuidv4();
        return (React.createElement(Group, null,
            React.createElement(Input, { id: this._id, type: "text", className: "custom", value: this.props.value, required: this.props.required, onChange: (event) => {
                    return this.props.onChange(event.target.value);
                }, onClick: (event) => {
                    if (this.props.formContext.commandRegistry) {
                        const path = this.props.formContext.commandRegistry.execute(COMMAND_SELECT_FILE, { filter: ['.gq.yaml'] });
                        path.then((d) => {
                            if (d) {
                                //event.currentTarget.value = d.path;
                                this.props.onChange(d.path);
                            }
                            // eslint-disable-next-line prettier/prettier
                        });
                    }
                } }),
            React.createElement("button", { onClick: () => {
                    const inputEle = document.getElementById(this._id);
                    if (this.props.formContext.commandRegistry) {
                        this.props.formContext.commandRegistry.execute(COMMAND_OPEN_DOC_FORWARD, { path: inputEle.value });
                    }
                } }, "Show Taskgraph")));
    }
}
export class CsvFileSelector extends React.Component {
    constructor(props) {
        super(props);
    }
    render() {
        const Input = styled.input `
      width: 100%;
    `;
        return (React.createElement(Input, { type: "text", className: "custom", value: this.props.value, required: this.props.required, onChange: (event) => {
                return this.props.onChange(event.target.value);
            }, onClick: (event) => {
                if (this.props.formContext.commandRegistry) {
                    const path = this.props.formContext.commandRegistry.execute(COMMAND_SELECT_FILE, { filter: ['.csv', '.csv.gz'] });
                    path.then((d) => {
                        if (d) {
                            //event.currentTarget.value = d.path;
                            this.props.onChange(d.path);
                        }
                        // eslint-disable-next-line prettier/prettier
                    });
                }
            } }));
    }
}
export class FileSelector extends React.Component {
    constructor(props) {
        super(props);
    }
    render() {
        const Input = styled.input `
      width: 100%;
    `;
        return (React.createElement(Input, { type: "text", className: "custom", value: this.props.value, required: this.props.required, onChange: (event) => {
                return this.props.onChange(event.target.value);
            }, onClick: (event) => {
                if (this.props.formContext.commandRegistry) {
                    const path = this.props.formContext.commandRegistry.execute(COMMAND_SELECT_FILE);
                    path.then((d) => {
                        if (d) {
                            this.props.onChange(d.path);
                        }
                        // eslint-disable-next-line prettier/prettier
                    });
                }
            } }));
    }
}
export class PathSelector extends React.Component {
    constructor(props) {
        super(props);
    }
    render() {
        const Input = styled.input `
      width: 100%;
    `;
        return (React.createElement(Input, { type: "text", className: "custom", value: this.props.value, required: this.props.required, onChange: (event) => {
                return this.props.onChange(event.target.value);
            }, onClick: (event) => {
                console.log('event');
                console.log(this.props);
                if (this.props.formContext.commandRegistry) {
                    const path = this.props.formContext.commandRegistry.execute(COMMAND_SELECT_PATH);
                    path.then((d) => {
                        if (d) {
                            this.props.onChange(d.path);
                        }
                    });
                }
            } }));
    }
}
