import { JupyterFrontEndPlugin } from '@jupyterlab/application';
import { Token } from '@lumino/coreutils';
import { LabIcon, ContextMenuSvg } from '@jupyterlab/ui-components';
import { CommandRegistry } from '@lumino/commands';
import { ICommandPalette, IWidgetTracker } from '@jupyterlab/apputils';
import { GquantWidget } from './document';
import { Menu } from '@lumino/widgets';
import '../style/editor.css';
export declare const FACTORY = "GQUANTLAB";
declare type IGQUANTTracker = IWidgetTracker<GquantWidget>;
export declare const gqIcon: LabIcon;
export declare const runIcon: LabIcon;
export declare const cleanIcon: LabIcon;
export declare const layoutIcon: LabIcon;
export declare const IGQUANTTracker: Token<IGQUANTTracker>;
export declare function isLinkedView(currentWidget: any): boolean;
export declare function isEnabled(cell: any): boolean;
export declare function setupContextMenu(contextMenu: ContextMenuSvg, commands: CommandRegistry, palette: ICommandPalette): Promise<Menu>;
/**
 * Export the plugins as default.
 */
declare const plugins: JupyterFrontEndPlugin<any>[];
export default plugins;
