// eslint-disable-next-line @typescript-eslint/no-unused-vars
import { ReactWidget } from '@jupyterlab/apputils';
import React from 'react';
// eslint-disable-next-line @typescript-eslint/no-unused-vars
import { ChartEngine } from './chartEngine';
const OUTPUT_CELL_HEIGHT = 300;
export const OUTPUT_COLLECTOR = 'collector_id_fd9567b6';
export const OUTPUT_TYPE = 'Output_Collector';
export class MainView extends ReactWidget {
    constructor(contentHandler) {
        super();
        this._contentHandler = contentHandler;
        this.addClass('jp-GQuant');
        this.firstTimeReSize = false;
    }
    _calclateSize() {
        this._height = OUTPUT_CELL_HEIGHT;
        const cell = this.parent.parent.parent.parent.parent.parent;
        this._width = cell.inputArea.editorWidget.node.clientWidth - 5;
        //this._width = this.parent.parent.parent.node.clientWidth;
        // console.log('nsize', this._height, this._width);
        if (!this._contentHandler) {
            return;
        }
        if (!this._contentHandler.privateCopy) {
            return;
        }
        if (this._contentHandler.aspectRatio) {
            this._height = this._width * this._contentHandler.aspectRatio;
        }
    }
    /**
     * This is used exclusively to handle the gquantlab widget resize event in the cell output of the notebook
     *
     */
    mimerenderWidgetUpdateSize() {
        this._calclateSize();
        if (!this._contentHandler.privateCopy) {
            return;
        }
        if (!this._contentHandler.privateCopy.get('cache')) {
            return;
        }
        if (!this._contentHandler.privateCopy.get('cache').nodes) {
            return;
        }
        this._contentHandler.sizeStateUpdate.emit({
            nodes: [],
            edges: [],
            width: this._width,
            height: this._height
        });
        // update the result size
        const pane = this.parent;
        if (pane.widgets.length === 3) {
            const view = pane.widgets[2];
            view.node.style.width = this._width + 'px';
        }
        // const content: IChartInput = this._contentHandler.privateCopy.get('cache');
        // content['width'] = this._width;
        // content['height'] = this._height;
        // this._contentHandler.contentChanged.emit(content);
    }
    onAfterAttach(msg) {
        console.log('attached');
        super.onAfterAttach(msg);
        this._calclateSize();
        if (!this._contentHandler.privateCopy) {
            return;
        }
        if (!this._contentHandler.privateCopy.get('value')) {
            return;
        }
        this._contentHandler.renderGraph(this._contentHandler.privateCopy.get('value'), this._width, this._height);
    }
    get contentHandler() {
        return this._contentHandler;
    }
    onResize(msg) {
        this._height = msg.height;
        this._width = msg.width;
        console.log('resize', this._height, this._width);
        if (this._height < 0 || this._width < 0) {
            // this is a hack that onResize doesn't work for rendered widget
            this.mimerenderWidgetUpdateSize();
            return;
        }
        if (!this.firstTimeReSize) {
            this._contentHandler.emit(this._width, this._height);
            this.firstTimeReSize = true;
        }
        else {
            this._contentHandler.sizeStateUpdate.emit({
                nodes: [],
                edges: [],
                width: this._width,
                height: this._height
            });
        }
    }
    render() {
        console.log('re render');
        return (React.createElement("div", null,
            React.createElement(ChartEngine, { contentHandler: this._contentHandler })));
    }
}
